#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> inline void chkmax(T &x, const T1 &y) { if (x < y) x = y; }
template<class T, class T1> inline void chkmin(T &x, const T1 &y) { if (x > y) x = y; }

const int MAXN = 150000;
int N, K;
int A[MAXN];
int sA[MAXN];

void read()
{
    cin >> N >> K;
    for (int i = 0; i < N; i++)
    {
        cin >> A[i];
        sA[i] = A[i];
    }
}

int cnt[MAXN];
int dp[MAXN];

void solve_slow()
{
    set<int> u;
    for (int len = N; len > 0; len--)
    {
        for (int i = 0; i <= N - len; i++)
        {
            u.clear();
            for (int j = i; j < i + len; j++)
                u.insert(A[j]);
            if ((int)u.size() <= K)
            {
                cout << len << ' ' << i + 1 << endl;
                return;
            }
        }
    }
}

void solve()
{
    solve_slow();
    return;
//    int max_len = 1, max_index = 0;
//    int curr_index = 0, curr_len = 1;
//    set<int> used;
//    used.clear();
//    used.insert(A[0]);
//    for (int i = 1; i < N; i++)
//    {
//        if ((int)used.size() == K)
//        {
//            if (curr_len > max_len)
//            {
//                max_len = curr_len;
//                max_index = curr_index;
//            }
//            curr_len = 1;
//            curr_index = i;
//            used.clear();
//            used.insert(A[i]);
//            continue;
//        }
//        if (used.count(A[i]) > 0)
//            curr_len++;
//        else
//        {
//            curr_len++;
//            used.insert(A[i]);
//        }
//    }
//    ///TODO: check if cnt is larger than k
//    if (curr_len > max_len)
//    {
//        max_len = curr_len;
//        max_index = curr_index;
//    }
//    cout << max_len << ' ' << max_index + 1 << endl;
    sort(sA, sA + N);
    int max_len = 1;
    cnt[0] = 1;
    for (int i = 1; i < N; i++)
    {
        cnt[i] = cnt[i - 1];
        if (sA[i] != sA[i - 1])
            cnt[i]++;
    }
    dp[0] = 1;
    for (int i = 1; i < N; i++)
    {
        int mv = 0;
        for (int j = i - 1; j >= 0; j--)
        {
            int val = cnt[j];
            if (sA[i] != sA[j])
                val++;
            if ((dp[j] > mv) && (val <= K))
                mv = dp[j];
        }
        dp[i] = mv + 1;
        chkmax(max_len, dp[i]);
    }
    cout << max_len << ' ';
    set<int> u;
    for (int i = 0; i <= N - max_len; i++)
    {
        u.clear();
        for (int j = i; j < i + max_len; j++)
            u.insert(A[j]);
        if ((int)u.size() <= K)
        {
            cout << i + 1 << endl;
            return;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    read();
    solve();

    return EXIT_SUCCESS;
}

