#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;
int n;
vector <int> g [100005];
bool blocked [100005];
bool used [100005];
int p [100005];
vector <int> ans;
void bfs (int a){
	vector <int> oblast;
	queue <int> q;
	q.push (a);
	oblast.push_back (a);
	used [a] = 1;
	p [a] = 0;
	while (!q.empty ()){
		a = q.front ();
		q.pop ();
		for (int i : g [a]){
			if (!used [i]){
				used [i] = 1;
				q.push (i);
				oblast.push_back (i);
				p [i] = p [a] + 1;
			}
		}
	}
	sort (oblast.begin (), oblast.end ());
	int sz= oblast.size ();
	if (sz % 2 == 0){
		int P = p [oblast [0]] % 2;
		for (int i : oblast){
			if (p [i] % 2 == P) ans.push_back (i);
		}
	}
	if (sz % 2 == 1){
		for (int i : oblast){
			if (!blocked [i]){
				for (int x : g [i]) blocked [x] = 1;
				ans.push_back (i);
			}
		}
	}
}
bool MIZERIQ [16];
bool check (){
	for (int i = 1; i <= n; i ++){
		if (MIZERIQ [i])
		for (int j = i + 1; j <= n; j ++){
			if (MIZERIQ [j]) if (g [i][0] == j || g [i][1]== j) return 0;
		}
	}
	return 1;
}	
bool mizeriq (int i){
	if (i < n){
		MIZERIQ [i]= 1;
		bool dali = mizeriq (i + 1);
		if (dali) return true;
		if (!dali){
			MIZERIQ [i] = 0;
			return mizeriq (i + 1);
		}
	}
	bool dali = check ();
	if (dali){
		for (int i = 1; i <= n; i ++){
			if (MIZERIQ [i]) br ++;
		}
		cout << br << '\n';
		for (int i = 1; i <= n; i ++){
			if (MIZERIQ [i]) cout << i << ' ';
		}
		cout << '\n';
		return 1;
	}
	return 0;
}
int main (){

	ios::sync_with_stdio (false);
	cin.tie (nullptr);
	cin >> n;
	for (int i = 0; i < n; i ++){
		int u, v;
		cin >> u >> v;
		g [u].push_back (v);
		g [v].push_back (u);
	}
	if (n <= 10){
		bool dali = mizeriq (1);
		return 0;
	}
	for (int i = 1; i <= n; i ++){
		if (!used [i]) bfs (i);

	}
	sort (ans.begin (), ans.end ());
	int sz = ans.size ();
	cout << sz << '\n' << ans [0];
	for (int i = 1; i < sz; i ++) cout << ' ' << ans [i];
	cout << '\n';

	return 0;
}
