#include <bits/stdc++.h>
#define MAXN 100003
using namespace std;
int n;
vector <int> edges[MAXN];
int type[MAXN];
vector <int> ans;
void bfs(int start)
{
    queue <int> q;
    q.push(start);
    type[start] = 1;
    while (!q.empty())
    {
        int curr = q.front();
        q.pop();
        for (int i: edges[curr])
            if (!type[i])
        {
            if (type[curr] == 1)
                 type[i] = 2;
            else
            {
                type[i] = 1;
                ans.push_back(i);
            }
            q.push(i);
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        int a, b;
        cin >> a >> b;
        edges[a].push_back(b);
        edges[b].push_back(a);
    }
    for (int i = 1; i <= n; i++)
        if (!type[i])
    {
        ans.push_back(i);
        bfs(i);
    }
    sort (ans.begin(), ans.end());
    cout << ans.size() << endl;
    cout << ans[0];
    for (int i = 1; i < ans.size(); i++)
        cout << " " << ans[i];
    cout << endl;
}
