#include <bits/stdc++.h>
#define MAXN 100003
using namespace std;
int n;
vector <int> edges[MAXN];
bool used[MAXN];
vector <int> ans;
vector <int> cycle;
void dfs(int v)
{
    used[v] = true;
    cycle.push_back(v);
    for (int i: edges[v])
        if (!used[i])
        dfs(i);
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    for (int i = 1; i <= n; i++)
    {
        int a, b;
        cin >> a >> b;
        edges[a].push_back(b);
        edges[b].push_back(a);
    }
    for (int i = 1; i <= n; i++)
        if (!used[i])
    {
        dfs(i);
        ans.push_back(i);
        if ((cycle.size()-3) % 2 == 1)
            for (int i = 2; i < cycle.size()-1; i += 2)
                ans.push_back(cycle[i]);
        else
        {
            vector <int> v1;
            vector <int> v2;
            for (int i = 2; i < cycle.size()-1; i += 2)
                v1.push_back(cycle[i]);
            for (int i = 3; i < cycle.size()-1; i += 2)
                v2.push_back(cycle[i]);
            sort (v1.begin(), v1.end());
            sort (v2.begin(), v2.end());
            if (v1.empty()) continue;
            if (v1[0] < v2[0])
                for (int j: v1)
                ans.push_back(j);
            else
                for (int j: v2)
                ans.push_back(j);
        }
        cycle.clear();
    }
    sort (ans.begin(), ans.end());
    cout << ans.size() << endl;
    cout << ans[0];
    for (int i = 1; i < ans.size(); i++)
        cout << " " << ans[i];
    cout << endl;
}
