#include<iostream>
long long mults[1000000];
long long n,m;
long long mpow(long long a,long long b){
    if(b==1){
        return a;
    }
    long long num=mpow(a,b/2);
    long long res;
    if(b%2==0){
        res=num*num%m;
    }else{
        res=num*num*a%m;
    }
    if(res==0){
        return 1;
    }
    return res;
}
long long eratosten[1000002];
int main(){
    std::cin>>n>>m;
    int k=0;
    for(int i=2;i<m;i++){
        if(m%i==0 && !eratosten[i]){
            for(int j=i;j<m;j+=i){
                eratosten[j]=1;
            }
        }
        if(!eratosten[i]){
            k++;
        }
    }
    long long a=n*n;
    for(long long i=0;i<=m;i++){
        mults[i]+=a/m;
        if(i<a%m){
            mults[i]++;
        }
    }
    a=n*n/4;
    for(long long i=0;i<=m;i++){
        mults[i]-=a/m;
        if(i<a%m){
            mults[i]--;
        }
    }
    a=3*n*n/4;
    for(long long i=0;i<=m;i++){
        mults[i]-=a/m;
        if(i<a%m){
            mults[i]--;
        }
    }
    long long num=1;
    for(long long i=0;i<=m;i++){
        while(mults[i]>0){
            num=num*(i+1);
            num=num%m;
            mults[i]--;
        }
    }
    for(long long i=0;i<=m;i++){
        while(mults[i]<0){
            num=num*mpow(i+1,k);
            num=num%m;
            mults[i]++;
        }
    }
    num=num%m;
    a=n*n/2;
    for(long long i=0;i<=m;i++){
        mults[i]+=a/m;
        if(i<a%m){
            mults[i]++;
        }
    }
    a=n*n/8;
    for(long long i=0;i<=m;i++){
        mults[i]-=a/m;
        if(i<a%m){
            mults[i]--;
        }
    }
    a=3*n*n/8;
    for(long long i=0;i<=m;i++){
        mults[i]-=a/m;
        if(i<a%m){
            mults[i]--;
        }
    }
    long long num2=1;
    for(long long i=0;i<=m;i++){
        while(mults[i]>0){
            num2=num2*(i+1);
            num2=num2%m;
            mults[i]--;
        }
    }
    for(long long i=0;i<=m;i++){
        while(mults[i]<0){
            num2=num2*mpow(i+1,k);
            num2=num2%m;
            mults[i]++;
        }
    }
    num2=num2%m;
    if(n%4!=0){
        num2=0;
    }
    std::cout<<(num-num2+m)%m<<std::endl;
    return 0;
}
