# include <iostream>
# include <cstdio>
# include <vector>
# include <algorithm>
using namespace std;
int a[1000005];
int tree[2000005];
int n;
void update(int v, int l, int r, int q, int p)
{
    tree[v]=max(tree[v],p);
    int mid=(l+r)/2;
    if(q>=l&&q<=mid&&l!=r)update(v*2,l,mid,q,p);
    if(q<=r&&q>mid&&l!=r)update(v*2+1,mid+1,r,q,p);
}
int find(int v, int l, int r, int x, int y)
{
    if(l>=x&&r<=y)return tree[v];
    int mid=(l+r)/2;
    int maxs=0;
    if(x<=mid&&y>=l)maxs=max(maxs,find(2*v,l,mid,x,y));
    if(x<=r&&y>mid)maxs=max(maxs,find(2*v+1,mid+1,r,x,y));
    return maxs;
}
int solve(int from, int to)
{
    if(to-from<=0)return 0;
    if(to-from==1)return max(a[from],a[to]);
    int pos=find(1,1,n,from,to);
    int ans=solve(from,pos-1)+solve(pos+1,to);
    if(pos!=from)ans+=a[pos];
    if(pos!=to)ans+=a[pos];
    return ans;
}
int main()
{

scanf("%d",&n);
int i;
for(i=1;i<=n;i++)
{
    scanf("%d",&a[i]);
    update(1,1,n,i,a[i]);
}
int ans=solve(1,n);
cout<<ans<<endl;
return 0;
}
