#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> inline void chkmax(T &x, const T1 &y) { if (x < y) x = y; }
template<class T, class T1> inline void chkmin(T &x, const T1 &y) { if (x > y) x = y; }

const int MAXN = 150000;
int N, K;
int A[MAXN];

void read()
{
    cin >> N >> K;
    for (int i = 0; i < N; i++)
        cin >> A[i];
}

bool check(int len, int &pos)
{
    /*
    set<int> u;
    for (int i = 0; i <= N - len; i++)
    {
        u.clear();
        for (int j = i; j < i + len; j++)
            u.insert(A[j]);
        if ((int)u.size() <= K)
        {
            pos = i;
            return true;
        }
    }
    return false;
    */
    map<int, int> el;
    el.clear();
    for (int i = 0; i < len; i++)
    {
        if (el.count(A[i]) == 0)
            el[A[i]] = 1;
        else
            el[A[i]]++;
    }
    if ((int)el.size() <= K)
    {
        pos = 0;
        return true;
    }
    for (int i = 1; i <= N - len; i++)
    {
        el[A[i - 1]]--;
        el[A[i + len - 1]]++;
        if (el[A[i - 1]] == 0)
            el.erase(el.find(A[i - 1]));
        if ((int)el.size() <= K)
        {
            pos = i;
            return true;
        }
    }
    return false;
}

void solve()
{
    int l = 1, r = N;
    int mid, len;
    int curr_pos, answer_pos;
    while (l <= r)
    {
        mid = (l + r) >> 1;
        if (check(mid, curr_pos))
        {
            len = mid;
            answer_pos = curr_pos;
            l = mid + 1;
        }
        else
            r = mid - 1;
    }
    cout << len << ' ' << answer_pos + 1 << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    read();
    solve();

    return EXIT_SUCCESS;
}

