#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
template<class T, class T1> inline void chkmax(T &x, const T1 &y) { if (x < y) x = y; }
template<class T, class T1> inline void chkmin(T &x, const T1 &y) { if (x > y) x = y; }
typedef long long ll;

int n;
vector<int> a;

void read()
{
    cin >> n;
    for (int i = 0; i < n; i++)
    {
        int val;
        cin >> val;
        a.push_back(val);
    }
}

ll reduce(int i, vector<int> &v)
{
    ll answer = (ll)max(v[i], v[i + 1]);
    if (v[i] < v[i + 1])
        v.erase(v.begin() + i);
    else
        v.erase(v.begin() + (i + 1));
    return answer;
}

vector<int> moves;

ll dp[1000005];

ll F(int len)
{
    if (len == 1)
    {
        ll ans = 0ll;
        vector<int> check = a;
        for (const auto &it : moves)
            ans += reduce(it, check);
        return ans;
    }
    if (dp[len] != -1)
        return dp[len];
    ll answer = LLONG_MAX;
    for (int i = 0; i < len - 1; i++)
    {
        moves.push_back(i);
        chkmin(answer, F(len - 1));
        moves.pop_back();
    }
    return dp[len] = answer;
}

void solve()
{
    /*
    moves.clear();
    memset(dp, -1ll, sizeof(dp));
    ll answer = F(n);
    cout << answer << endl;
    */
    dp[0] = 0ll;
    dp[1] = max(a[0], a[1]);
    ll add = 3ll;
    for (int i = 2; i < n; i++)
        dp[i] = dp[i - 1] + add, add++;
    cout << dp[n - 1] << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    a.clear();

    read();
    solve();

    return EXIT_SUCCESS;
}

