#include<iostream>

using namespace std;

long long a[1000001];
pair<long long,long> st[4000001];
long long n;

void init(long long ind,long long l,long long r)
{
    if(l==r)
    {
        st[ind]=make_pair(a[l],l);
        return;
    }

    long long mid=(l+r)/2;

    init(2*ind,l,mid);
    init(2*ind+1,mid+1,r);

    st[ind]=max(st[2*ind],st[2*ind+1]);
}

pair<long long,long long> query(long long ind,long long l,long long r,long long sl,long long sr)
{
    if(l>sr || r<sl)
        return make_pair(0,0);
    if(sl<=l && r<=sr)
        return st[ind];

    int mid=(l+r)/2;

    return max(query(2*ind,l,mid,sl,sr),query(2*ind+1,mid+1,r,sl,sr));
}

long long solve(long long l,long long r)
{
    if(l==r)
        return 0;

    pair<long long,long long> p=query(1,1,n,l,r);

    //cout<<l<<"  "<<r<<" = "<<p.second<<endl;

    if(p.second==l)
        return solve(l+1,r)+p.first;
    if(p.second==r)
        return solve(l,r-1)+p.first;

    return solve(l,p.second-1)+solve(p.second+1,r)+2*p.first;
}

int main ()
{
    long long i;

    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>n;

    for(i=1;i<=n;i++)
        cin>>a[i];

    init(1,1,n);

    cout<<solve(1,n)<<"\n";

    return 0;
}
