#include<iostream>
#include<vector>

using namespace std;

const int N=100007;

int n;
vector<int> adj[N];
bool visited[N];
bool in[N];

int dfs(int v,int p,int f)
{
    visited[v]=1;

    if(f==v)
        return 1;

    int i;

    for(i=0;i<2;i++)
    {
        int to=adj[v][i];

        if(to==p)
            continue;

        return 1+dfs(to,v,f);
    }

    return 0;
}

void solve(int v)
{
    visited[v]=1;
    in[v]=1;

    int i,l,r;

    for(i=0;i<2;i++)
    {
        int to=adj[v][i];

        visited[to]=1;
    }

    if(adj[v][0]==adj[v][1])
        return;

    for(i=0;i<2;i++)
    {
        int to=adj[adj[v][0]][i];

        if(to==v)
            continue;

        l=to;
    }

    for(i=0;i<2;i++)
    {
        int to=adj[adj[v][1]][i];

        if(to==v)
            continue;

        r=to;
    }

    int cnt=dfs(l,adj[v][0],r)-3;

    //cout<<cnt<<endl;

    if(cnt%2==1)
    {
        in[l]=1;
        in[r]=1;
        int pr=adj[v][0];
        while(l!=r)
        {
            in[l]=1;
            for(i=0;i<2;i++)
            {
                if(adj[l][i]==pr)
                    continue;

                pr=l;
                l=adj[l][i];
                break;
            }
            for(i=0;i<2;i++)
            {
                if(adj[l][i]==pr)
                    continue;

                pr=l;
                l=adj[l][i];
                break;
            }
        }
        return;
    }

    int sl,sr,prl,prr;

    prl=adj[v][0];
    prr=adj[v][1];

    while(cnt>0 && cnt%2==0)
    {
       for(i=0;i<2;i++)
        {
            if(adj[l][i]==prl)
                continue;

            sl=adj[l][i];
        }

        for(i=0;i<2;i++)
        {
            if(adj[r][i]==prr)
                continue;

            sr=adj[r][i];
        }

        prl=l;
        prr=r;

        l=min(sl,l);
        r=min(sr,r);

        int x=min(l,r);

        if(x!=prr && x!=prl)
        {
            if(x==sr)
            {
                r=sr;
                for(i=0;i<2;i++)
                {
                    if(adj[r][i]==prr)
                        continue;

                    prr=r;
                    r=adj[r][i];
                    break;
                }
                for(i=0;i<2;i++)
                {
                    if(adj[r][i]==prr)
                        continue;

                    prr=r;
                    r=adj[r][i];
                    break;
                }


                l=prl;
                cnt-=3;
                break;
            }
            else
            {
                l=sl;

                for(i=0;i<2;i++)
                {
                    if(adj[l][i]==prl)
                        continue;

                    prl=l;
                    l=adj[l][i];
                    break;
                }
                for(i=0;i<2;i++)
                {
                    if(adj[l][i]==prl)
                        continue;

                    prl=l;
                    l=adj[l][i];
                    break;
                }

                r=prr;
                cnt-=3;
                break;
            }
        }
        else
        {
            if(x==prr)
            {
                r=sr;
                for(i=0;i<2;i++)
                {
                    if(adj[r][i]==prr)
                        continue;

                    prr=r;
                    r=adj[r][i];
                    break;
                }


                l=prl;
                cnt-=2;
            }
            else
            {
                l=sl;

                for(i=0;i<2;i++)
                {
                    if(adj[l][i]==prl)
                        continue;

                    prl=l;
                    l=adj[l][i];
                    break;
                }

                r=prr;
                cnt-=2;
            }
        }
    }

    if(cnt%2==1)
    {
        in[l]=1;
        in[r]=1;
        int pr=adj[v][0];
        while(l!=r)
        {
            in[l]=1;
            for(i=0;i<2;i++)
            {
                if(adj[l][i]==pr)
                    continue;

                pr=l;
                l=adj[l][i];
                break;
            }
            for(i=0;i<2;i++)
            {
                if(adj[l][i]==pr)
                    continue;

                pr=l;
                l=adj[l][i];
                break;
            }
        }
        return;
    }

    return;
}

vector<int> output;

int main ()
{
    int n,i,x,y;

    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>n;

    for(i=0;i<n;i++)
    {
        cin>>x>>y;
        adj[x].push_back(y);
        adj[y].push_back(x);
    }

    for(i=1;i<=n;i++)
        if(!visited[i])
            solve(i);

    for(i=1;i<=n;i++)
        if(in[i])
            output.push_back(i);

    cout<<output.size()<<"\n";

    for(i=0;i<output.size()-1;i++)
        cout<<output[i]<<" ";
    if(output.size())cout<<output[i]<<"\n";

    return 0;
}
