#include<iostream>
#include<vector>

using namespace std;

const int N=100007;

vector<int> adj[N];
bool visited[N];
bool res[N];
bool visitedCircle[N];
vector<int> output;

void dfs(int v,int p,bool b)
{
    if(visited[v])
        return;

    visited[v]=1;
    if(b)
        res[v]=1;

    for(int i=0;i<adj[v].size();i++)
    {
        int to=adj[v][i];

        if(to==p)
            continue;
        dfs(to,v,!b);
    }
}

int dfs2(int v,int p)
{
    int r=1;

    if(res[v])
        return 1;

    visitedCircle[v]=1;

    for(int i=0;i<adj[v].size();i++)
    {
        int to=adj[v][i];

        if(to==p)
            continue;

        r+=dfs2(to,v);
    }

    return r;
}

void dfs3(int v,int p,bool b,int fin)
{
    if(v==fin)
        return;

    if(b)
        visited[v]=1;

    for(int i=0;i<adj[v].size();i++)
    {
        int to=adj[v][i];

        if(to==p)
            continue;

        dfs3(to,v,!b,fin);
    }
}

void f(int v)
{
    visited[v]=1;
    res[v]=1;

    for(int i=0;i<adj[v].size();i++)
    {
        int to=adj[v][i];
        visited[to]=1;
    }

    if(visitedCircle[v])
    {
        dfs(adj[v][0],v,0);
        dfs(adj[v][1],v,0);
    }
    else
    {
        int cnt=dfs2(adj[v][0],v);

        if(cnt%2==0)
        {
            dfs3(adj[v][0],v,1,v);
        }
    }
}

int main ()
{
    int n,i,x,y;

    ios::sync_with_stdio(false);
    cin.tie(NULL);

    cin>>n;

    for(i=0;i<n;i++)
    {
        cin>>x>>y;

        adj[x].push_back(y);
        adj[y].push_back(x);
    }

    for(i=1;i<=n;i++)
        if(!visited[i])
        {
            //res.push_back(i);
            f(i);
        }

    for(i=1;i<=n;i++)
        if(res[i])
            output.push_back(i);

    cout<<output.size()<<"\n";

    for(i=0;i<output.size()-1;i++)
        cout<<output[i]<<" ";
    if(output.size())cout<<output[i]<<"\n";

    return 0;
}
