#include <iostream>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;
int n;
vector <int> g [100005];
bool blocked [100005];
bool used [100005];
int p [100005];
vector <int> ans;
void bfs (int a){
	vector <int> oblast;
	queue <int> q;
	q.push (a);
	oblast.push_back (a);
	used [a] = 1;
	p [a] = 0;
	while (!q.empty ()){
		a = q.front ();
		q.pop ();
		for (int i : g [a]){
			if (!used [i]){
				used [i] = 1;
				q.push (i);
				oblast.push_back (i);
				p [i] = p [a] + 1;
			}
		}
	}
	sort (oblast.begin (), oblast.end ());
	int sz= oblast.size ();
	if (sz % 2 == 0){
		int P = p [oblast [0]] % 2;
		for (int i : oblast){
			if (p [i] % 2 == P) ans.push_back (i);
		}
	}
	if (sz % 2 == 1){
		for (int i : oblast){
			if (!blocked [i]){
				blocked [g [i][0]] = 1;
				blocked [g [i][1]] = 1;
				ans.push_back (i);
			}
		}
	}
}
int main (){

	ios::sync_with_stdio (false);
	cin.tie (nullptr);
	cin >> n;
	for (int i = 0; i < n; i ++){
		int u, v;
		cin >> u >> v;
		g [u].push_back (v);
		g [v].push_back (u);
	}
	for (int i = 1; i <= n; i ++){
		if (!used [i]) bfs (i);

	}
	sort (ans.begin (), ans.end ());
	int sz = ans.size ();
	cout << sz << '\n';
	for (int i : ans) cout << i << ' ';
	cout << '\n';

	return 0;
}
