#include <bits/stdc++.h>
#define MAXN 1000003
using namespace std;
typedef long long ll;
int n;
ll arr[MAXN];
pair <ll, ll> tr[4*MAXN];
void build(int v, int l, int r)
{
    if (l == r)
    {
        tr[v].first = arr[l];
        tr[v].second = l;
        return;
    }
    int mid = (l + r) >> 1;
    build(v << 1, l, mid);
    build((v << 1) + 1, mid + 1 ,r);
    if (tr[v << 1].first >= tr[(v << 1) + 1].first)
        tr[v] = tr[v << 1];
    else
        tr[v] = tr[(v << 1) + 1];
}
pair <ll, ll> get(int v, int l, int r, int x, int y)
{
    if (l > y || r < x) return make_pair(0, 0);
    if (l >= x && r <= y) return tr[v];
    int mid = (l + r) >> 1;
    auto first = get(v << 1, l, mid, x, y);
    auto second = get((v << 1) + 1, mid+1, r, x, y);
    if (first.first >= second.first) return first;
    return second;
}
ll calc(int l, int r)
{
    if (l >= r) return 0;
    auto curr = get(1, 1, n, l, r);
    ll ans = 0;
    if (curr.second > l)
        ans += calc(l, curr.second-1) + curr.first;
    if (curr.second < r)
        ans += calc(curr.second+1, r) + curr.first;
    return ans;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    for (int i = 1; i <= n; i++)
        cin >> arr[i];
    build(1, 1, n);
    cout << calc(1, n) << endl;
}
